/* Problem URL: https://codeforces.com/gym/103960/problem/H */

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

template <class T, class comp = less<>>
using ordered_set = tree<T, null_type , comp , rb_tree_tag , tree_order_statistics_node_update>;

#define V vector

#define rmin(a, b) a = min(a, b)
#define rmax(a, b) a = max(a, b)

#define rep(i, lim) for (int i = 0; i < (lim); i++)
#define nrep(i, s, lim) for (int i = s; i < (lim); i++)

#define repv(i, v) for (auto &i : (v))
#define fillv(v) for (auto &itr_ : (v)) { cin >> itr_; }
#define sortv(v) sort(v.begin(), v.end())
#define all(v) (v).begin(), (v).end()

using vi = vector<int>;
using vvi = vector<vi>;
using vvvi = vector<vvi>;
using vvvvi = vector<vvvi>;

using ll = long long;

using vl = vector<ll>;
using vvl = vector<vl>;
using vvvl = vector<vvl>;
using vvvvl = vector<vvvl>;

template<class v>
auto operator<<(ostream &os, const vector<v> &vec)->ostream& {
    os << vec[0];
    for (size_t i = 1; i < vec.size(); i++) {
        os << ' ' << vec[i];
    }
    os << '\n';
    return os;
}

template<class v>
auto operator>>(istream &is, vector<v> &vec)->istream& {
    for (auto &i : vec) {
        is >> i;
    }
    return is;
}

template<class v>
auto operator<<(ostream &os, const vector<vector<v>> &vec)->ostream& {
    for (auto &i : vec) {
        os << i[0];
        for (size_t j = 1; j < i.size(); j++) {
            os << ' ' << i[j];
        }
        os << '\n';
    }
    return os;
}

template<class v>
auto operator>>(istream  &is, vector<vector<v>> &vec)->istream& {
    for (auto &i : vec) {
        for (auto &j : i) {
            is >> j;
        }
    }
    return is;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, m;
    cin >> n >> m;

    vvi graph(n);
    vvi inv(n);
    vvi comp(n);

    while (m--) {
        int a, b;
        cin >> a >> b;
        a--, b--;

        graph[a].push_back(b);
        inv[b].push_back(a);
        comp[a].push_back(b);
        comp[b].push_back(a);
    }

    stack<int> preorder;

    V<bool> vis(n);

    function<void(int)> getpre = [&](int i) {
        vis[i] = true;

        for (auto j : graph[i]) {
            if (vis[j]) {
                continue;
            }

            getpre(j);
        }

        preorder.push(i);
    };

    rep(i, n) {
        if (vis[i]) {
            continue;
        }

        getpre(i);
    }

    int g = 0;
    fill(all(vis), false);
    V<set<int>> condin;
    V<set<int>> condout;
    vi group(n, -1);

    function<void(int)> dfs = [&](int i) {
        vis[i] = true;
        group[i] = g;

        for (auto j : inv[i]) {
            if (group[j] != -1 && group[j] != g) {
                condin[g].insert(group[j]);
                condout[group[j]].insert(g);
                continue;
            }

            if (vis[j]) {
                continue;
            }

            dfs(j);
        }
    };

    while (!preorder.empty()) {
        int i = preorder.top();
        preorder.pop();

        if (vis[i]) {
            continue;
        }

        condin.emplace_back();
        condout.emplace_back();
        dfs(i);
        g++;
    }

    if (g == 1) {
        cout << "0\n";
        return 0;
    }

    int nonein = 0;
    int noneout = 0;

    rep(i, g) {
        if (condin[i].empty()) {
            nonein++;
        }

        if (condout[i].empty()) {
            noneout++;
        }
    }

    cout << max(nonein, noneout) << '\n';
}
